<template>
  <div class="mb-3">
    <v-card tile>
      <crud-data-table
        :headers="headers"
        :items="installments"
        sort-by="referenceMonth"
        :items-per-page="-1"
        hide-default-footer
        hide-slot-top
        dense
      >
        <template v-slot:referenceMonth="{ item: { referenceMonth } }">
          {{ referenceMonth | formatMonth }}
        </template>

        <template v-slot:amount="{ item: { amount } }">
          {{ amount | formatCurrency }}
        </template>

        <template v-slot:dueDate="{ item: { dueDate } }">
          {{ dueDate | formatDate | symbolWhenEmpty }}
        </template>

        <template v-slot:paidOutAt="{ item: { paidOutAt } }">
          {{ paidOutAt | formatDate | symbolWhenEmpty }}
        </template>

        <template v-slot:createdAt="{ item: { createdAt } }">
          {{ createdAt | formatDateToRelativeTime }}
        </template>

        <template v-slot:updatedAt="{ item: { updatedAt } }">
          {{ updatedAt | formatDateToRelativeTime }}
        </template>
      </crud-data-table>
    </v-card>
  </div>
</template>

<script>
  import DatesMixin from '@/mixins/date'
  import MoneyMixin from '@/mixins/money'
  import UtilsMixin from '@/mixins/utils'
  import getTableHeaders from './table-headers'

  export default {
    name: 'AmountsTable',
    mixins: [DatesMixin, MoneyMixin, UtilsMixin],
    props: {
      installments: {
        type: Array,
        required: true,
      },
    },
    data () {
      return {
        onDeleteIncomeAmountCallback: null,
        headers: getTableHeaders(key => this.$t(key)),
      }
    },
  }
</script>
